<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/28/2003 *
 * ===================                          Last change: 04/03/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-email_archiv .php                           *
 * -------------------------------------------------------------------- *
 * Short description : See send emails details of ordered mails         *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Alle  Mails ansehen die versand wurden           *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 * -------------------------------------------------------------------- *
 * Mod-Copyright (c) 2004 by Robert Niedziela                           *
 * www.megacomputing.de                                                 *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Init SQL string
$sql = "SELECT
	`id`, `sender`, `subject`, `text`, `receivers`, `payment_id`, `data_type`, `timestamp`, `url`, `target_send`, `cat_id`
FROM
	`{?_MYSQL_PREFIX?}_pool`
WHERE
	`data_type`='SEND' OR `data_type`='DELETED'
ORDER BY
	`timestamp` DESC";

// Check for maximum pages
$result_maximum = SQL_QUERY($sql, __FILE__, __LINE__);

// Set offset an current page to default values
if (!isGetRequestParameterSet('page'))   setGetRequestParameter('page'  , 1);
if (!isGetRequestParameterSet('offset')) setGetRequestParameter('offset', getConfig('mails_page'));

// Add limitation to SQL string
$sql .= " LIMIT ".(getRequestParameter('offset') * getRequestParameter('page') - getRequestParameter('offset')) . ', ' . getRequestParameter('offset');

// Run SQL query for normal mails
$result = SQL_QUERY($sql, __FILE__, __LINE__);

// Calculate pages
$pages = round(SQL_NUMROWS($result_maximum) / getConfig('mails_page') + 0.5);

// Free the result which we don't need
SQL_FREERESULT($result_maximum);

if (SQL_NUMROWS($result) > 0) {
	// Mail orders are in pool so we can display them

	// Add navigation table rows
	$content['top_email_nav']    = '';
	$content['bottom_email_nav'] = '';
	if ($pages > 1) {
		$content['top_email_nav']    = addEmailNavigation($pages, getConfig('mails_page'), true , 3, true);
		$content['bottom_email_nav'] = addEmailNavigation($pages, getConfig('mails_page'), false, 3, true);
	} // END - if

	// List all entries
	$OUT = ''; $SW = 2;
	while ($pool = SQL_FETCHARRAY($result)) {
		// Check sent mails and clicks
		$result_mails = SQL_QUERY_ESC("SELECT `max_rec`, `clicks` FROM `{?_MYSQL_PREFIX?}_user_stats` WHERE `pool_id`=%s LIMIT 1",
			array(bigintval($pool['id'])), __FILE__, __LINE__);

		// Load entries
		$pool = merge_array($pool, SQL_FETCHARRAY($result_mails));

		// Merge result
		SQL_FREERESULT($result_mails);

		// Unconfirmed mails
		$pool['unconfirmed'] = $pool['max_rec'] - $pool['clicks'];
		if ($pool['unconfirmed'] > 0) {
			// Add link to list_unconfirmed what-file
			$pool['unconfirmed'] = '<strong><a href="{%url=modules.php?module=admin&amp;what=list_unconfirmed&amp;mid=' . $pool['id'] . '%}">' . $pool['unconfirmed'] . '</a></strong>';
		} // END - if

		// Prepare data for the row template
		$content = merge_array($content, array(
			'sw'          => $SW,
			'u_link'      => generateUserProfileLink($pool['sender']),
			'subject'     => $pool['subject'],
			'text'        => $pool['text'],
			'pay'         => getPaymentTitlePrice($pool['payment_id']),
			'cat'         => getCategory($pool['cat_id']),
			'sent'        => $pool['max_rec'],
			'ruserids'    => convertReceivers($pool['receivers']),
			'unconfirmed' => $pool['unconfirmed'],
			'type'        => translatePoolType($pool['data_type']),
			'target_send' => $pool['target_send'],
			'frametester' => generateFrametesterUrl($pool['url']),
			'url'         => $pool['url'],
			'timestamp'   => generateDateTime($pool['timestamp'], 0),
			'mid'         => $pool['id'],
		));

		// Load row template and switch colors
		$OUT .= loadTemplate('admin_email_archiv_row', true, $content);
		$SW = 3 - $SW;
	} // END - while

	// Remmber generated rows in array
	$content['rows'] = $OUT;

	// Load main template
	loadTemplate('admin_email_archiv', false, $content);
} else {
	// No mail orders fond
	loadTemplate('admin_settings_saved', false, getMessage('ADMIN_NO_MAILS_IN_POOL'));
}

// Free memory
SQL_FREERESULT($result);

// [EOF]
?>
