<?php
/************************************************************************
 * Mailer v0.2.1-FINAL                                Start: 09/28/2003 *
 * ===================                          Last change: 05/13/2004 *
 *                                                                      *
 * -------------------------------------------------------------------- *
 * File              : what-memedit.php                                 *
 * -------------------------------------------------------------------- *
 * Short description : Edit member's menu                               *
 * -------------------------------------------------------------------- *
 * Kurzbeschreibung  : Editieren Sie das Menue fuer Ihre Mitglieder     *
 * -------------------------------------------------------------------- *
 * $Revision::                                                        $ *
 * $Date::                                                            $ *
 * $Tag:: 0.2.1-FINAL                                                 $ *
 * $Author::                                                          $ *
 * Needs to be in all Files and every File needs "svn propset           *
 * svn:keywords Date Revision" (autoprobset!) at least!!!!!!            *
 * -------------------------------------------------------------------- *
 * Copyright (c) 2003 - 2009 by Roland Haeder                           *
 * For more information visit: http://www.mxchange.org                  *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston,               *
 * MA  02110-1301  USA                                                  *
 ************************************************************************/

// Some security stuff...
if ((!defined('__SECURITY')) || (!isAdmin())) {
	die();
} // END - if

// Add description as navigation point
addMenuDescription('admin', __FILE__);

// Do we edit/delete/change main menus or sub menus?
$AND = "(`what` = '' OR `what` IS NULL)"; $SUB = '';

if (isGetRequestParameterSet('sub')) {
	$AND = sprintf("`action`='%s' AND `what` IS NOT NULL", getRequestParameter('sub'));
	$SUB = getRequestParameter('sub');
} // END - if

// List all menu points and make them editable
if ((isPostRequestParameterSet('edit')) && (countPostSelection() > 0) && (!isDemoModeActive())) {
	// Edit menu entries
	$content['sub'] = $SUB;
	$content['chk'] = countPostSelection();
	$SW = 2; $cnt = '0'; $OUT = '';
	foreach (postRequestParameter('sel') as $sel => $confirm) {
		if ($confirm == 1) {
			$cnt++;
			$result = SQL_QUERY_ESC("SELECT `title`, `action`, `what` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE ".$AND." AND `id`=%s LIMIT 1",
				array(bigintval($sel)), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == 1) {
				// Entry found so we load the stuff...
				$data = SQL_FETCHARRAY($result);
				$data = array(
					'cnt'    => $cnt,
					'sel'    => $sel,
					'menu'   => $data['title'],
					'sw'     => $SW,
					'act'    => adminAddMenuSelectionBox('member', 'act' , 'sel_act['  . $sel . ']', $data['action']),
					'what'   => adminAddMenuSelectionBox('member', 'what', 'sel_what[' . $sel . ']', $data['what']),
				);

				// Load template
				$OUT .= loadTemplate('admin_mmenu_edit_row', true, $data);
			} else {
				// Entry not found?
				$data = array(
					'sw'  => $SW,
					'sel' => $sel
				);

				// Load template
				$OUT .= loadTemplate('admin_menu_404_row', true, $data);
			}
			SQL_FREERESULT($result);
			$SW = 3 - $SW;
		}
	}
	$content['rows'] = $OUT;
	$content['cnt'] = $cnt;

	// Load template
	loadTemplate('admin_mmenu_edit', false, $content);
} elseif ((isPostRequestParameterSet('del')) && (countPostSelection() > 0) && (!isDemoModeActive())) {
	// Del menu entries with or without confirmation
	$content['sub'] = $SUB;
	$content['chk'] = countPostSelection();
	$SW = 2; $cnt = '0'; $OUT = '';
	foreach (postRequestParameter('sel') as $sel => $confirm) {
		if ($confirm == 1) {
			$cnt++;
			$result = SQL_QUERY_ESC("SELECT `title` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE ".$AND." AND `id`=%s LIMIT 1",
				array(bigintval($sel)), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == 1) {
				// Entry found so we load the stuff...
				list($title) = SQL_FETCHROW($result);
				$content = array(
					'cnt'   => $cnt,
					'sel'   => $sel,
					'title' => $title
				);

				// Load template
				$OUT .= loadTemplate('admin_mmenu_delete_row', true, $content);
			} else {
				// Entry not found?
				$content = array(
					'sw'  => $SW,
					'sel' => $sel
				);

				// Load template
				$OUT .= loadTemplate('admin_menu_404_row', true, $content);
			}
			SQL_FREERESULT($result);
		} // END - if
	} // END - foreach
	$content['rows'] = $OUT;
	$content['cnt'] = $cnt;

	// Load template
	loadTemplate('admin_mmenu_delete', false, $content);
} elseif ((isPostRequestParameterSet('status')) && (countPostSelection() > 0) && (!isDemoModeActive())) {
	// Change status (visible / locked)
	$content['sub'] = $SUB;
	$content['chk'] = countPostSelection();
	$SW = 2; $cnt = '0'; $OUT = '';
	foreach (postRequestParameter('sel') as $sel => $confirm) {
		if ($confirm == 1) {
			$cnt++;
			$result = SQL_QUERY_ESC("SELECT `title`, `visible`, `locked` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE ".$AND." AND `id`=%s LIMIT 1",
				array(bigintval($sel)), __FILE__, __LINE__);
			if (SQL_NUMROWS($result) == 1) {
				// Entry found so we load the stuff...
				$data = SQL_FETCHARRAY($result);
				$data = array(
					'cnt'     => $cnt,
					'menu'    => $data['title'],
					'sel'     => $sel,
					'sw'      => $SW,
					'visible' => addSelectionBox('yn', $data['visible'], 'visible', $sel),
					'locked'  => addSelectionBox('yn', $data['locked'] , 'locked' , $sel),
				);

				// Load template
				$OUT .= loadTemplate('admin_menu_status_row', true, $data);
			} else {
				// Entry not found?
				$data = array(
					'sw'  => $SW,
					'sel' => $sel
				);

				// Load template
				$OUT .= loadTemplate('admin_menu_404_row', true, $data);
			}
			SQL_FREERESULT($result);
			$SW = 3 - $SW;
		} // END - if
	} // END - foreach
	$content['rows'] = $OUT;
	$content['cnt'] = $cnt;

	// Load template
	loadTemplate('admin_mmenu_status', false, $content);
} elseif ((isFormSent()) && (!isDemoModeActive())) {
	// An act is done...
	foreach (postRequestParameter('sel') as $sel => $menu) {
		$AND = "(`what` = '' OR `what` IS NULL)";
		$sel = bigintval($sel);
		if (!empty($SUB)) $AND = "`action`='".$SUB."'";
		switch (postRequestParameter('ok')) {
			case 'edit': // Edit menu
				SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `title`='%s', `action`='%s', `what`='%s' WHERE ".$AND." AND `id`=%s LIMIT 1",
					array($menu, postRequestParameter('sel_act', $sel), postRequestParameter('sel_what', $sel), $sel), __FILE__, __LINE__);
				break;

			case 'del': // Delete menu
				SQL_QUERY_ESC("DELETE LOW_PRIORITY FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE ".$AND." AND `id`=%s LIMIT 1",
					array($sel), __FILE__, __LINE__);
				break;

			case 'status': // Change status of menus
				SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `visible`='%s', `locked`='%s' WHERE ".$AND." AND `id`=%s LIMIT 1",
					array(postRequestParameter('visible', $sel), postRequestParameter('locked', $sel), $sel), __FILE__, __LINE__);
				break;
		} // END - switch
		break;
	} // END - foreach

	// Load template
	loadTemplate('admin_settings_saved', false, getMessage('SETTINGS_SAVED'));
} else {
	if ((isGetRequestParameterSet('act')) && (isGetRequestParameterSet('tid')) && (isGetRequestParameterSet('fid'))) {
		// Init
		$tid = ''; $fid = '';

		// Get ids
		if (isGetRequestParameterSet('w')) {
			// Sub menus selected
			$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `action`='%s' AND `sort`='%s' LIMIT 1",
				array(bigintval(getRequestParameter('act')), bigintval(getRequestParameter('tid'))), __FILE__, __LINE__);
			list($tid) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);
			$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE `action`='%s' AND `sort`='%s' LIMIT 1",
				array(bigintval(getRequestParameter('act')), bigintval(getRequestParameter('fid'))), __FILE__, __LINE__);
			list($fid) = SQL_FETCHROW($result);
			SQL_FREERESULT($result);
		} else {
			// Main menu selected
			$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE (`what`='' OR `what` IS NULL) AND `sort`='%s' LIMIT 1",
				array(bigintval(getRequestParameter('tid'))), __FILE__, __LINE__);
			list($tid) = SQL_FETCHROW($result);
			$result = SQL_QUERY_ESC("SELECT `id` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE (`what`='' OR `what` IS NULL) AND `sort`='%s' LIMIT 1",
				array(bigintval(getRequestParameter('fid'))), __FILE__, __LINE__);
			list($fid) = SQL_FETCHROW($result);
		}

		if ((!empty($tid)) && (!empty($fid))) {
			// Sort menu
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `sort`='%s' WHERE ".$AND." AND `id`=%s LIMIT 1",
				array(bigintval(getRequestParameter('tid')), bigintval($fid)), __FILE__, __LINE__);
			SQL_QUERY_ESC("UPDATE `{?_MYSQL_PREFIX?}_member_menu` SET `sort`='%s' WHERE ".$AND." AND `id`=%s LIMIT 1",
				array(bigintval(getRequestParameter('fid')), bigintval($tid)), __FILE__, __LINE__);
		} // END - -fi
	} // END - if

	if (!empty($SUB)) {
		// Edit sub menus
		$result = SQL_QUERY("SELECT `id`, `action`, `what`, `title`, `sort` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE ".$AND." AND `what` != '' AND `what` IS NOT NULL ORDER BY `sort` ASC", __FILE__, __LINE__);
	} else {
		// Edit main menus
		$result = SQL_QUERY("SELECT `id`, `action`, `what`, `title`, `sort` FROM `{?_MYSQL_PREFIX?}_member_menu` WHERE (`what`='' OR `what` IS NULL) ORDER BY `sort` ASC", __FILE__, __LINE__);
	}

	// Get total menu entries
	$max = SQL_NUMROWS($result);

	// Some are there?
	if ($max > 0) {
		// Set sub value
		$content['sub'] = $SUB;

		$SW = 2; $cnt = '0'; $OUT = '';
		while ($data = SQL_FETCHARRAY($result)) {
			// Init navigation
			$data['navi'] = '';
			$cnt++;
			if (($data['sort'] == '0') || (($data['sort'] == 1) && (!empty($SUB)))) {
				// Is highest position
				$data['navi'] = '<a href="{%url=modules.php?module=admin&amp;what=adminedit&amp;sub=' . $content['sub'] . '&amp;act=' . $data['action'] . '&amp;w=' . $data['what'] . '&amp;tid=' . ($data['sort']+1) . '&amp;fid=' . $data['sort'] . '%}">{--LOWER--}</a>';
			} elseif ($cnt == $max) {
				// Is lowest position
				$data['navi'] = '<a href="{%url=modules.php?module=admin&amp;what=adminedit&amp;sub=' . $content['sub'] . '&amp;act=' . $data['action'] . '&amp;w=' . $data['what'] . '&amp;tid=' . ($data['sort']-1) . '&amp;fid=' . $data['sort'] . '%}">{--HIGHER--}</a>';
			} elseif ($data['sort'] > 0) {
				// Anything else between highest and lowest
				$data['navi'] = '<a href="{%url=modules.php?module=admin&amp;what=adminedit&amp;sub=' . $content['sub'] . '&amp;act=' . $data['action'] . '&amp;w=' . $data['what'] . '&amp;tid=' . ($data['sort']-1) . '&amp;fid=' . $data['sort'] . '%}">{--HIGHER--}</a>/<a href="{%url=modules.php?module=admin&amp;what=memedit&amp;sub=' . $content['sub'] . '&amp;act=' . $data['action'] . '&amp;w=' . $data['what'] . '&amp;tid=' . ($data['sort']+1) . '&amp;fid=' . $data['sort'] . '%}">{--LOWER--}</a>';
			}

			// Fix empty values for Firefox
			if (empty($data['action'])) $data['action'] = '&nbsp;';
			if (empty($data['what']))   $data['what']   = '&nbsp;';
			if (empty($data['title']))  $data['title']  = '&nbsp;';

			// Add more entries
			$data['sw']   = $SW;
			$data['mode'] = 'mem';

			// Load row template and switch color
			$OUT .= loadTemplate('admin_menu_overview_row', true, $data);
			$SW = 3 - $SW;
		} // END - while

		// Free memory
		SQL_FREERESULT($result);

		// Remember rows in array
		$content['rows'] = $OUT;

		// Load main template
		loadTemplate('admin_mmenu_overview', false, $content);
	} else {
		// Menu entries are missing... (???)
		loadTemplate('admin_settings_saved', false, getMessage('ADMIN_NO_MENUS_FOUND'));
	}
}

// [EOF]
?>
